Bug 5797 - Allow native library in class library
Summary: Allow native library in class library
Status: RESOLVED FIXED
Alias: None
Product: Android
Classification: Xamarin
Component: MSBuild (show other bugs)
Version: 4.2.x
Hardware: PC Windows
: Normal normal
Target Milestone: ---
Assignee: Atsushi Eno
URL:
Depends on:
Blocks:
 
Reported: 2012-06-21 06:56 UTC by Sebastian Krysmanski
Modified: 2013-07-18 09:51 UTC (History)
3 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on Developer Community or GitHub with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Sebastian Krysmanski 2012-06-21 06:56:37 UTC
It should be possible to add a native library (VS Build Action: AndroidNativeLibrary) to an "Android Class Library" project.

You can do this with MfA 4.2 but the library can't be found by P/Invoke when doing this. So, currently the native library must be located in executable/main project.
Comment 1 Atsushi Eno 2013-05-22 17:00:12 UTC
It is now supported in 4.6 and 4.7.x (AndroidNativeLibrary in 4.6, plus EmbeddedNativeLibrary in 4.7.x).
Comment 2 Goncalo Oliveira 2013-07-18 05:20:33 UTC
This doesn't work on 4.6.08007 (0cc7ae3b). The build action is there but the library can't be found by P/Invoke. Only works if the native library is included in the main project.
Comment 3 Atsushi Eno 2013-07-18 09:51:14 UTC
You need to use EmbeddedNativeLibrary in library project if you do not want to include it in the main project. If you do understand that and still believe it doesn't work, please provide a reproducible project that "should" work.